//////////////////////////////////////////////////////////////////////////////////////
//
//	Autor: 		Jens Wei
//	Date. 		12.09.2012
//
//	Projekt: 	Laser Exposer
//	Module: 	Motor Controller
//	Funktion: 	Der Motor Controller steuert den Polygonspiegel und sorgt
//				dafr, dass sich der Spiegel mit einer festen Geschwindigkeit dreht.
//				Die Frequenz wird so eingestellt, dass der Laser genau 3ms braucht 
//				fr eine Zeile.
//
//////////////////////////////////////////////////////////////////////////////////////

#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include "pwm.h"


void pwm_init(void)
{
	TCCR1A |= (1<<COM1A1)|(1<<COM1A0)|(1<<WGM11)|(1<<WGM10); //10-bit PWM Mode 3
	TCCR1B |= (1<<CS11)|(1<<CS10);							//Prescaler 64
	OCR1A = 0;

	DDRB |= (1<<3);											//PWM PIN auf Ausgang
}

void timer_init(void)
{
	TCCR0B |= (1<<CS01);		//clk/8 prescaling
	TIMSK |= (1<<TOIE0);		//Timer0 Overflow Interrupt enable
}

void set_pwm(unsigned int pwm)
{
	OCR1A = pwm;
}
