//////////////////////////////////////////////////////////////////////////////////////
//
//	Autor: 		Jens Wei
//	Date. 		12.09.2012
//
//	Projekt: 	Laser Exposer
//	Module: 	Motor Controller
//	Funktion: 	Der Motor Controller steuert den Polygonspiegel und sorgt
//				dafr, dass sich der Spiegel mit einer festen Geschwindigkeit dreht.
//				Die Frequenz wird so eingestellt, dass der Laser genau 3ms braucht 
//				fr eine Zeile.
//
//////////////////////////////////////////////////////////////////////////////////////

#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include "pwm.h"
#include "regler.h"

long int e = 0;
long int y = 0;
long int esum = 0;
long int ealt = 0;
int Kp = -5;
int Kp_Teiler = 10;
int I = -1;  
int I_Teiler = 100;

int PI_Berechnung (unsigned long int x, unsigned long int w)
{    
	e = w - x;                	// aktuelle Regelabweichung bestimmen

	if ((y < 1023)&&(y > 0))  	// bei bersteuertem Stellglied Integration einfrieren
	{                       	// (Anti-Windup)
	    esum = esum + e;      	// Summe der Regelabweichung aktualisieren  
	}
	y = (Kp*e)/Kp_Teiler + (I*esum)/I_Teiler;  	// Reglergleichung
	ealt = e;                 	// Regelabweichung fr nchste Abtastung merken

	if (y > 1023)             	// Stellgre auf 0..1023 begrenzen (10 bit PWM)
	{
	    y = 1023;
	}
	if (y < 1)
	{
	    y = 0;
	}

	if((e > -100) && (e < 100))
	{
		LED_PORT |= (1<<LED_BIT);
	}
	else
	{
		LED_PORT &= ~(1<<LED_BIT);
	}

	return (int)y;             	// Stellgre zurckgeben
}

void init_INT0(void)
{
	MCUCR |= (1<<ISC01);		//falling edge of INT0 generates an interrupt
	GIMSK |= (1<<INT0);			//INT0 request enabled
}
 

